package www.application.service;

import org.springframework.stereotype.Service;
import www.application.port.in.SyncPersonUseCase;
import www.application.port.out.PersonByEmailPort;
import www.application.port.out.SaveUpdatePersonPort;
import www.domain.Person;
import javax.transaction.Transactional;
import java.util.Optional;


@Transactional
@Service
public class SyncPersonService implements SyncPersonUseCase {

    private final PersonByEmailPort personByEmailPort;
    private final SaveUpdatePersonPort saveUpdatePersonPort;
    private final CreateDefaultChatService createDefaultChatService;

    public SyncPersonService(PersonByEmailPort personByEmailPort, SaveUpdatePersonPort saveUpdatePersonPort, CreateDefaultChatService createDefaultChatService) {
        this.personByEmailPort = personByEmailPort;
        this.saveUpdatePersonPort = saveUpdatePersonPort;
        this.createDefaultChatService = createDefaultChatService;
    }


    @Override
    public boolean syncPerson(Person person) {
        /*
            The incoming Person has all the attributes from the Oidc-IdToken, like Roles, email, etc.
            It was generated by the EventConsumerAdapter, which has the RabbitMqConsumer listening
            to UserLogins.
         */

        // If Person does NOT exist in the DB yet, create it as well as a default Chat with wwweasel !
        Optional<Person> persistedPerson = this.personByEmailPort.personByEmail(person.getEmail());

        if( persistedPerson.isEmpty() ){
            System.out.println( "Will create default Chat for new person: " + person.getEmail() );
            person = this.createDefaultChatService.createDefaultChat( person );
        }
        // Remember, the following will either update the persistedPerson or save a new person
        this.saveUpdatePersonPort.saveUpdatePerson(person);

        return true;

    }

}
